"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("./index");
var index_2 = require("./index");
function execute(argv) {
    var args = argv
        .filter(function (_, i) { return i > 1; });
    var argumentDependencies = args
        .filter(function (arg) { return arg.substr(0, 1) !== '-'; });
    var options = args
        .filter(function (arg) { return arg.substr(0, 1) === '-'; });
    var l = console.log;
    if (options.indexOf('--help') >= 0 || options.indexOf('-h') >= 0) {
        l();
        l('Install packages locally.');
        l();
        l('Usage:');
        l(' install-local');
        l(' install-local [options] <directory>[, <directory>, ...]');
        l();
        l('Installs packages from the filesystem into the current directory.');
        l();
        l('Options: ');
        l();
        l(' -h, --help      Output this help');
        l(' -S, --save      Saved packages will appear in your package.json under "localDependencies"');
        l();
        l('Examples: ');
        l(' install-local');
        l('   install the "localDependencies" of your current package');
        l(' install-local ..');
        l('   install the package located in the parent folder into the current directory.');
        l(' install-local --save ../sibling ../sibling2');
        l('   install the packages of 2 sibling directories into the current directory and save them to "localDependencies" in your package.json file.');
        return Promise.resolve();
    }
    else {
        return index_1.readLocalDependencies(argumentDependencies).then(function (localDependencies) {
            var installer = new index_1.LocalInstaller({ '.': localDependencies });
            index_1.progressBar(installer);
            installer.install()
                .then(index_2.saveIfNeeded(options));
        });
    }
}
exports.execute = execute;
//# sourceMappingURL=cli.js.map