"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var fs = require("mz/fs");
function readLocalDependencies(dependenciesFromArguments) {
    if (dependenciesFromArguments.length) {
        return Promise.resolve(dependenciesFromArguments);
    }
    else {
        return fs.readFile('package.json', 'utf8').then(JSON.parse).then(function (pkg) {
            if (pkg.localDependencies) {
                return _.values(pkg.localDependencies);
            }
            else {
                return [];
            }
        });
    }
}
exports.readLocalDependencies = readLocalDependencies;
//# sourceMappingURL=readLocalDependencies.js.map